/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.compiler;

import kmy.jint.typer.AbstractVariable;
import java.io.IOException;
import kmy.jint.gen.CodeGenerator;
import kmy.jint.reflect.AbstractClass;

abstract class CompilerVariable extends AbstractVariable
{
  abstract void genGet( CodeGenerator gen, CompilerContext context ) throws IOException;
  abstract void genPut( CodeGenerator gen, CompilerContext context ) throws IOException;

  abstract AbstractClass getBase( CompilerContext context );

  /**
   *  Generate variable initialization code.
   */
  void genInit( CodeGenerator gen, CompilerContext context ) throws IOException
  {
    getBase( context );
  }

  void setFieldMode( boolean fieldMode )
  {
  }

  void genRet( CodeGenerator gen, CompilerContext context ) throws IOException
  {
    throw new RuntimeException( "Should not be called!" );
  }

  void setRegister( int reg )
  {
    throw new RuntimeException( "Should not be called!" );
  }

  int getRegister()
  {
    return -1;
  }

  public int getFilePos()
  {
    return -1;
  }
}




