/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.constants;

public interface ErrorCodes extends MiniErrorCodes
{
  // lexer errors

  int ERR_L_IOERROR       = ERR_MASK_LEXER      | ERR_MASK_ERROR    | 0x0001;
  int ERR_L_BACKSLASHEOF  = ERR_MASK_LEXER      | ERR_MASK_ERROR    | 0x0002;
  int ERR_L_STRINGEND     = ERR_MASK_LEXER      | ERR_MASK_ERROR    | 0x0003;
  int ERR_L_EOFINSTRING   = ERR_MASK_LEXER      | ERR_MASK_ERROR    | 0x0004;
  int ERR_L_EOFINCHAR     = ERR_MASK_LEXER      | ERR_MASK_ERROR    | 0x0005;
  int ERR_L_EMPTYCHAR     = ERR_MASK_LEXER      | ERR_MASK_ERROR    | 0x0006;
  int ERR_L_CHAREND       = ERR_MASK_LEXER      | ERR_MASK_ERROR    | 0x0007;
  int ERR_L_COMMENTEND    = ERR_MASK_LEXER      | ERR_MASK_ERROR    | 0x0008;
  int ERR_L_NUMFORMAT     = ERR_MASK_LEXER      | ERR_MASK_ERROR    | 0x0009;
  int ERR_L_REGEXEND      = ERR_MASK_LEXER      | ERR_MASK_ERROR    | 0x000A;
  int ERR_L_EOFINREGEX    = ERR_MASK_LEXER      | ERR_MASK_ERROR    | 0x000B;
  int ERR_L_ILLEGALCHAR   = ERR_MASK_LEXER      | ERR_MASK_ERROR    | 0x000C;

  int ERR_L_NEVER         = ERR_MASK_LEXER      | ERR_MASK_INTERNAL | 0x0001;

  // parser errors

  int ERR_P_TOKENINSERTED = ERR_MASK_PARSER     | ERR_MASK_WARNING  | 0x0001;
  int ERR_P_NOTSTANDALONE = ERR_MASK_PARSER     | ERR_MASK_WARNING  | 0x0002;

  int ERR_P_TOKENEXPECTED = ERR_MASK_PARSER     | ERR_MASK_ERROR    | 0x0001;
  int ERR_P_DUPEXTENDS    = ERR_MASK_PARSER     | ERR_MASK_ERROR    | 0x0002;
  int ERR_P_DUPIMPLEMENTS = ERR_MASK_PARSER     | ERR_MASK_ERROR    | 0x0003;
  int ERR_P_CASEEXPECTED  = ERR_MASK_PARSER     | ERR_MASK_ERROR    | 0x0004;
  int ERR_P_CATCHEXPECTED = ERR_MASK_PARSER     | ERR_MASK_ERROR    | 0x0005;
  int ERR_P_TYPEEXPECTED  = ERR_MASK_PARSER     | ERR_MASK_ERROR    | 0x0006;
  int ERR_P_UNEXPECTED    = ERR_MASK_PARSER     | ERR_MASK_ERROR    | 0x0007;
  int ERR_P_VAREXPECTED   = ERR_MASK_PARSER     | ERR_MASK_ERROR    | 0x0008;
  int ERR_P_VALUEEXPECTED = ERR_MASK_PARSER     | ERR_MASK_ERROR    | 0x0009;
  int ERR_P_OPEXPECTED    = ERR_MASK_PARSER     | ERR_MASK_ERROR    | 0x000A;
  int ERR_P_IDENTEXPECTED = ERR_MASK_PARSER     | ERR_MASK_ERROR    | 0x000B;
  int ERR_P_ARRNOTEMPTY   = ERR_MASK_PARSER     | ERR_MASK_ERROR    | 0x000C;
  int ERR_P_REGEXEXPECTED = ERR_MASK_PARSER     | ERR_MASK_ERROR    | 0x000D;

  int ERR_P_NOTIMPL       = ERR_MASK_PARSER     | ERR_MASK_FATAL    | 0x0001;

  int ERR_P_CLASSKEYWORD  = ERR_MASK_PARSER     | ERR_MASK_INTERNAL | 0x0001;

  // class table errors

  int ERR_T_CANTRESOLVE   = ERR_MASK_CLASSTABLE | ERR_MASK_ERROR    | 0x0001;
  int ERR_T_ARRNOTEMPTY   = ERR_MASK_CLASSTABLE | ERR_MASK_ERROR    | 0x0002;
  int ERR_T_NOTSIMPLEID   = ERR_MASK_CLASSTABLE | ERR_MASK_ERROR    | 0x0003;
  int ERR_T_IDEXPECTED    = ERR_MASK_CLASSTABLE | ERR_MASK_ERROR    | 0x0004;
  int ERR_T_NOTLIST       = ERR_MASK_CLASSTABLE | ERR_MASK_ERROR    | 0x0005;
  int ERR_T_MULTIINHERIT  = ERR_MASK_CLASSTABLE | ERR_MASK_ERROR    | 0x0006;

  int ERR_T_INTERNAL      = ERR_MASK_CLASSTABLE | ERR_MASK_INTERNAL | 0x0001;
  int ERR_T_ONFINISH      = ERR_MASK_CLASSTABLE | ERR_MASK_INTERNAL | 0x0002;

  // typer errors

  int ERR_A_IMPLICITDCL   = ERR_MASK_TYPER      | ERR_MASK_INFO     | 0x0001;

  int ERR_A_NOTTHROWN     = ERR_MASK_TYPER      | ERR_MASK_WARNING  | 0x0001;

  int ERR_A_VARREDECL     = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0001;
  int ERR_A_ARRNOTEMPTY   = ERR_MASK_CLASSTABLE | ERR_MASK_ERROR    | 0x0002;
  int ERR_A_ARREMPTY      = ERR_MASK_CLASSTABLE | ERR_MASK_ERROR    | 0x0003;
  int ERR_A_TYPEMISMATCH  = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0004;
  int ERR_A_TYPENOTFOUND  = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0005;
  int ERR_A_CANTACCLABEL  = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0006;
  int ERR_A_NOOUTERCLASS  = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0007;
  int ERR_A_BOOLCAST      = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0008;
  int ERR_A_VOIDCAST      = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0009;
  int ERR_A_TOBOOLCAST    = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x000A;
  int ERR_A_TOVOIDCAST    = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x000B;
  int ERR_A_OBJTOPRIMCAST = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x000C;
  int ERR_A_PRIMTOOBJCAST = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x000D;
  int ERR_A_CANTCAST      = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x000E;
  int ERR_A_NOTTHROWABLE  = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x000F;
  int ERR_A_MUSTBEBOOL    = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0010;
  int ERR_A_FIELDNOTSTAT  = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0011;
  int ERR_A_NOFIELD       = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0012;
  int ERR_A_NOVAR         = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0013;
  int ERR_A_INSTOFPRIM1   = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0014;
  int ERR_A_INSTOFPRIM2   = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0015;
  int ERR_A_MATCHARG1     = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0016;
  int ERR_A_MATCHARG2     = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0017;
  int ERR_A_REGEXTE       = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0018;
  int ERR_A_NOTLVALUE     = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0019;
  int ERR_A_NOTINTEGER    = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x001A;
  int ERR_A_NOTNUMBER     = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x001B;
  int ERR_A_LABELREDEF    = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x001C;
  int ERR_A_NOTSIMPLEID   = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x001D;
  int ERR_A_BADDCL        = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x001E;
  int ERR_A_NEWARRARGS    = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x001F;
  int ERR_A_NOCONSTRUCTOR = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0020;
  int ERR_A_EXPLCONTEXT   = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0021;
  int ERR_A_BADSWITCHTYPE = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0022;
  int ERR_A_PRIMSYNC      = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0023;
  int ERR_A_NOTINTARGS    = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0024;
  int ERR_A_NOBESTMATCH   = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0025;
  int ERR_A_BADMETHODNAME = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0026;
  int ERR_A_CANTRESOLVE   = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0027;
  int ERR_A_NOMETHOD      = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0028;
  int ERR_A_NOTINDEXABLE  = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x0029;
  int ERR_A_NOTCAUGHT     = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x002A;
  int ERR_A_STATICTHIS    = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x002B;
  int ERR_A_NONSTATICACC  = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x002C;
  int ERR_A_FIELDNOTIDENT = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x002D;
  int ERR_A_CONSTERROR    = ERR_MASK_TYPER      | ERR_MASK_ERROR    | 0x002E;

  int ERR_A_NEVER         = ERR_MASK_TYPER      | ERR_MASK_INTERNAL | 0x0001;
  int ERR_A_CANTMAKEARR   = ERR_MASK_TYPER      | ERR_MASK_INTERNAL | 0x0002;
  int ERR_A_INTERNAL      = ERR_MASK_TYPER      | ERR_MASK_INTERNAL | 0x0003;
  int ERR_A_BADOP         = ERR_MASK_TYPER      | ERR_MASK_INTERNAL | 0x0004;
  int ERR_A_PARAMUNRES    = ERR_MASK_TYPER      | ERR_MASK_INTERNAL | 0x0005;

  // compiler errors

  int ERR_C_GENERIC       = ERR_MASK_COMPILER   | ERR_MASK_INTERNAL;

  int ERR_C_CANTASSIGN    = ERR_MASK_COMPILER   | ERR_MASK_ERROR    | 0x0001;
  int ERR_C_CVTNULLTOPRIM = ERR_MASK_COMPILER   | ERR_MASK_ERROR    | 0x0002;
  int ERR_C_NOENCLOSING   = ERR_MASK_COMPILER   | ERR_MASK_ERROR    | 0x0003;
  int ERR_C_NOCNSTRWOPRM  = ERR_MASK_COMPILER   | ERR_MASK_ERROR    | 0x0004;
  int ERR_C_NONSTATINIT   = ERR_MASK_COMPILER   | ERR_MASK_ERROR    | 0x0005;
  int ERR_C_INTERFCONSTR  = ERR_MASK_COMPILER   | ERR_MASK_ERROR    | 0x0006;
  int ERR_C_THISASSIGN    = ERR_MASK_COMPILER   | ERR_MASK_ERROR    | 0x0007;
  int ERR_C_RETURNREQ     = ERR_MASK_COMPILER   | ERR_MASK_ERROR    | 0x0008;
  int ERR_C_CASEMISMATCH  = ERR_MASK_COMPILER   | ERR_MASK_ERROR    | 0x0009;
  int ERR_C_TWODEFAULT    = ERR_MASK_COMPILER   | ERR_MASK_ERROR    | 0x000A;
  int ERR_C_NOTBOOL       = ERR_MASK_COMPILER   | ERR_MASK_ERROR    | 0x000B;
  int ERR_C_PRIMELEM      = ERR_MASK_COMPILER   | ERR_MASK_ERROR    | 0x000C;
  int ERR_C_PICKEDNONSTR  = ERR_MASK_COMPILER   | ERR_MASK_ERROR    | 0x000D;
  int ERR_C_MATCHARG1     = ERR_MASK_COMPILER   | ERR_MASK_ERROR    | 0x000E;
  int ERR_C_DUPCASE       = ERR_MASK_COMPILER   | ERR_MASK_ERROR    | 0x000F;

  int ERR_C_INTERNAL      = ERR_MASK_COMPILER   | ERR_MASK_INTERNAL | 0x0001;
  int ERR_C_NESTING       = ERR_MASK_COMPILER   | ERR_MASK_INTERNAL | 0x0002;
  int ERR_C_NEVER         = ERR_MASK_COMPILER   | ERR_MASK_INTERNAL | 0x0003;
  int ERR_C_BADOP         = ERR_MASK_COMPILER   | ERR_MASK_INTERNAL | 0x0004;

}
