/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.io;

import java.io.*;

import kmy.jint.lang.ArgList;
import kmy.jint.lang.CharString;
import kmy.regex.util.Formatter;

public class JintWriter extends PrintWriter implements Flusher
{
  public JintWriter(Writer out)
  {
    super(out);
  }

  public JintWriter(Writer out, boolean autoFlush)
  {
    super(out,autoFlush);
  }

  public JintWriter(OutputStream out)
  {
    super(out);
  }

  public JintWriter(OutputStream out, boolean autoFlush)
  {
    super(out,autoFlush);
  }

  public void print( CharString str )
  {
    write( str.buf, str.first, str.last-str.first );
  }

  public void println( CharString str )
  {
    print( str );
    println();
  }

  public void printf( String format, ArgList list )
  {
    (new Formatter(format)).printf( this, list );
  }

  public void printf( Formatter format, ArgList list )
  {
    format.printf( this, list );
  }

  public void printlnf( String format, ArgList list )
  {
    (new Formatter(format)).printf( this, list );
    println();
  }

  public void printlnf( Formatter format, ArgList list )
  {
    format.printf( this, list );
    println();
  }

  public void flush()
  {
    super.flush();
  }
}
