/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.lang;

import kmy.jint.io.*;

public class IORedirectingThreadGroup extends ThreadGroup implements IORedirect
{

  private JintWriter out;
  private JintWriter err;
  private JintReader in;

  public IORedirectingThreadGroup( String name )
  {
    super(name);
    init();
  }

  public IORedirectingThreadGroup( ThreadGroup parent, String name )
  {
    super(parent,name);
    init();
  }

  private void init()
  {
    ThreadGroup parent = getParent();
    if( parent instanceof IORedirect )
      {
        IORedirect ior = (IORedirect)parent;
	in = ior.getStdin();
	out = ior.getStdout();
	err = ior.getStderr();
      }
  }

  public JintWriter getStdout()
  {
    return out;
  }

  public JintWriter getStderr()
  {
    return err;
  }

  public JintReader getStdin()
  {
    return in;
  }

  public void setStdout( JintWriter out )
  {
    this.out = out;
  }

  public void setStderr( JintWriter err )
  {
    this.err = err;
  }

  public void getStdin( JintReader in )
  {
    this.in = in;
  }

}
