/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.reflect;

import kmy.jint.constants.DefinitionConst;

abstract public class AbstractField implements DefinitionConst
{

  private String descriptor;

  public AbstractField()
  {
  }

  AbstractField( String dscr )
  {
    descriptor = dscr;
  }

  abstract public String        getName();
  abstract public int           getModifiers();
  abstract public AbstractClass getType();
  abstract public AbstractClass getDeclaringClass();

  void initDescriptor()
  {
    StringBuffer sb = new StringBuffer();
    sb.append( getDeclaringClass().getName() );
    sb.append( '/' );
    sb.append( getName() );
    descriptor = sb.toString();
  }

  public String getDescriptor()
  {
    if( descriptor == null )
      initDescriptor();
    return descriptor;
  }

  public String toString()
  {
    String cname = getClass().getName();
    int i = cname.lastIndexOf( '.' );
    if( i > 0 )
      cname = cname.substring( i + 1 );
    return cname + "[" + getDescriptor() + "]";    
  }

  public boolean isSimpleConst()
  {
    return (getModifiers() & CONST_FLAG) != 0;
  }

  public Object getConstValue()
  {
    return null;
  }

  public String getAccessor()
  {
    return null;
  }

}
