/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.reflect;

import kmy.jint.parser.Identifier;

public class AnyField extends AbstractField
{

  Identifier name;
  JintClassTable classTable;

  AnyField( JintClassTable ct, Identifier name )
  {
    this.name = name;
    classTable = ct;
  }

  public String getName()
  {
    return name.toString();
  }

  public Identifier getIdentifier()
  {
    return name;
  }

  public int getModifiers()
  {
    return PUBLIC_FLAG;
  }

  public AbstractClass getType()
  {
    return classTable.anyClass;
  }

  public AbstractClass getDeclaringClass()
  {
    return classTable.anyClass;
  }

  public JintClassTable getClassTable()
  {
    return classTable;
  }

}
