/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.reflect;

import kmy.jint.parser.Identifier;

public class AnyMethod extends AbstractMethod
{

  Identifier name;
  JintClassTable classTable;
  AbstractClass[] params;

  int modifiers = PUBLIC_FLAG;

  AnyMethod( JintClassTable ct, Identifier name, int nparam )
  {
    this.name = name;
    classTable = ct;
    params = new AbstractClass[nparam];
    for( int i = 0; i < nparam ; i++ )
      params[i] = ct.anyClass;
  }

  public String getName()
  {
    return name.toString();
  }

  public Identifier getIdentifier()
  {
    return name;
  }

  public int getModifiers()
  {
    return modifiers;
  }

  public AbstractClass getType()
  {
    return classTable.anyClass;
  }

  public AbstractClass getDeclaringClass()
  {
    return classTable.anyClass;
  }

  public AbstractClass[] getExceptionTypes()
  {
    return classTable.exceptionClassArr;
  }

  public AbstractClass[] getParameterTypes()
  {
    return params;
  }

  public void makeStatic()
  {
    modifiers |= STATIC_FLAG;
  }
}
