/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.reflect;

public class CompiledField extends AbstractField
{

  int flags;
  String name;
  CompiledClass clazz;
  AbstractClass type;
  Object value;

  CompiledField( int flags, CompiledClass clazz, String name, String descriptor, Object value )
  {
    super( descriptor );
    this.clazz = clazz;
    this.flags = flags;
    this.name = name;
    this.value = value;
  }

  public String getName()
  {
    return name;
  }

  public int getModifiers()
  {
    return flags;
  }

  public AbstractClass getType()
  {
    if( type == null )
      type = clazz.classTable.getClass( getDescriptor() );
    return type;
  }

  public AbstractClass getDeclaringClass()
  {
    return clazz;
  }

  public Object getConstValue()
  {
    return value;
  }
}
