/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.reflect;

import java.lang.reflect.*;
import kmy.jint.tree.DefinitionNode;

public class JVMField extends AbstractField
{

  Field          field;
  AbstractClass  declaring;
  AbstractClass  type;
  int            modifiers;

  JVMField( JintClassTable classTable, JVMClass declaring, Field field )
  {
    this.field = field;
    this.declaring = declaring;
    this.type = classTable.getClass( field.getType() );
    modifiers = DefinitionNode.fromJVMModifiers( field.getModifiers() );
  }

  public String getName()
  {
    return field.getName();
  }

  public int getModifiers()
  {
    return modifiers;
  }

  public AbstractClass getType()
  {
    return type;
  }

  public AbstractClass getDeclaringClass()
  {
    return declaring;
  }

  //-------- JVMField-specific stuff ----------

  public Field getField()
  {
    return field;
  }
}
