/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.reflect;

import kmy.jint.parser.Identifier;
import kmy.jint.parser.QualifiedIdentifier;

public class JintField extends AbstractField
{

  String         name;
  int            modifiers;
  JintClass      declaring;
  AbstractClass  type;
  int            id;
  Object         value;

  JintField( JintClassTable classTable, JintClass declaring,
	    int modifiers, Identifier name, QualifiedIdentifier type, int id )
  {
    this.declaring = declaring;
    this.modifiers = modifiers;
    if( type == null )
      this.type = classTable.anyClass;
    else
      this.type = classTable.getClass( type );
    this.name = name.toString();
    this.id = id;
  }

  JintField( JintClassTable classTable, JintClass declaring,
	    int modifiers, String name, AbstractClass type, int id )
  {
    this.declaring = declaring;
    this.modifiers = modifiers;
    this.type = ( type == null ? classTable.anyClass : type );
    this.name = name;
    this.id = id;
  }

  public String getName()
  {
    return name;
  }

  public int getModifiers()
  {
    return modifiers;
  }

  public AbstractClass getType()
  {
    return type;
  }

  public AbstractClass getDeclaringClass()
  {
    return declaring;
  }

  public Object getConstValue()
  {
    return value;
  }

  //--------- JintField specific

  public void setConstValue( Object v )
  {
    modifiers |= CONST_FLAG;
    value = v;
  }

  public int getOffset()
  {
    return id;
  }

}
