/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.tree;

public class ClassNode extends DefinitionNode
{
  public IdentifierNode name;
  public IdentifierNode[] parents;
  public IdentifierNode[] interfaces;
  public ClassNode[]      whereClauses;
  public StatementNode[]  statements;
  public RegexNode        regex;

  public ClassNode( IdentifierNode name, 
		    IdentifierNode[] parents,
		    IdentifierNode[] interfaces,
		    ClassNode[] wheres,
		    StatementNode[] statements
		  )
  {
    super( name == null ? -1 : name.getFilePos() );
    this.name         = name;
    this.parents      = parents;
    this.interfaces   = interfaces;
    this.whereClauses = wheres;
    this.statements   = statements;
  }

  public ClassNode( IdentifierNode name, RegexNode regex )
  {
    super( name == null ? -1 : name.getFilePos() );
    this.name  = name;
    this.regex = regex;
  }

  public Object eval( Context context )
  {
    return context.evalClass( this );
  }
}

