/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.tree;

import java.lang.reflect.Modifier;
import kmy.jint.constants.DefinitionConst;

public abstract class DefinitionNode extends StatementNode implements DefinitionConst
{

  int flags;

  public DefinitionNode( int filePos )
  {
    super( filePos );
  }

  public void addFlags( int f )
  {
    flags |= f;
  }

  public int getFlags()
  {
    return flags;
  }

  public static int fromJVMModifiers( int modifier )
  {
    int result = 0;
    if( (modifier & Modifier.PUBLIC) != 0 )
      result |= PUBLIC_FLAG;
    if( (modifier & Modifier.PRIVATE) != 0 )
      result |= PRIVATE_FLAG;
    if( (modifier & Modifier.STATIC) != 0 )
      result |= STATIC_FLAG;
    if( (modifier & Modifier.PROTECTED) != 0 )
      result |= PROTECTED_FLAG;
    if( (modifier & Modifier.SYNCHRONIZED) != 0 )
      result |= SYNCHRONIZED_FLAG;
    if( (modifier & Modifier.NATIVE) != 0 )
      result |= NATIVE_FLAG;
    if( (modifier & Modifier.FINAL) != 0 )
      result |= FINAL_FLAG;
    if( (modifier & Modifier.ABSTRACT) != 0 )
      result |= ABSTRACT_FLAG;
    return result;
  }
}

