/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.tree;

import kmy.jint.reflect.AbstractClass;

public abstract class ExpressionNode extends BasicNode
{
  /**
   *  Type of this expression. TyperContext fills this in.
   */
  public AbstractClass clazz;

  public static final Object NOT_CONST = new Object();

  public ExpressionNode( int filePos )
  {
    super( filePos );
  }

  /**
   *  Returns value of this expression (wrapped in the corresponding
   *  java class if value is primitive). If this expression is not
   *  constant, returns ExpressionNode.NOT_CONST.
   */
  public Object getConstValue()
  {
    return NOT_CONST;
  }

}
