/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.tree;

import kmy.regex.util.Formatter;
import kmy.jint.util.CompilerException;

public class FormatNode extends TextProcessingNode
{
  public boolean   bound;
  public String    formStr;
  public int       flags;
  public Formatter format;

  public FormatNode( int filePos, boolean withVariables, String formStr, int flags )
  {
    super( filePos );
    this.bound = withVariables;
    this.formStr  = formStr;
    this.flags = flags;
    try
      {
	format = new Formatter( formStr, withVariables );
      }
    catch( CompilerException e )
      {
	e.setFilePos( filePos );
	throw e;
      }
  }

  public Object eval( Context context )
  {
    return context.evalFormat( this );
  }
}
