/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.tree;

import kmy.jint.constants.TokenConst;
import kmy.jint.constants.ErrorCodes;
import kmy.jint.util.AnyUtilities;
import kmy.jint.util.CompilerException;

public class PrefixNode extends ExpressionNode implements ErrorCodes
{

  public int op;
  public ExpressionNode arg;

  public PrefixNode( int filePos, int op, ExpressionNode arg )
  {
    super( filePos );
    this.op = op;
    this.arg = arg;
  }

  public Object eval( Context context )
  {
    return context.evalPrefix( this );
  }

  public Object getConstValue()
  {
    try
      {
	Object v = arg.getConstValue();
	if( v == NOT_CONST )
	  return v;
	return AnyUtilities.op( op, v );
      }
    catch( CompilerException e )
      {
	throw e;
      }
    catch( RuntimeException e )
      {
	throw new CompilerException( ERR_A_CONSTERROR, getFilePos(), e );
      }
  }

}
