/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.tree;

import kmy.regex.tree.RNode;
import kmy.jint.constants.TokenConst;
import kmy.jint.constants.ErrorCodes;
import kmy.regex.parser.RParser;
import kmy.jint.util.CompilerException;

import java.util.Hashtable;

public class RegexNode extends TextProcessingNode implements ErrorCodes
{
  public String  str;
  public int     flags;
  public boolean embed;
  public RNode   regexNode;

  public String[] refList;
  public String[] pickList;
  
  public Hashtable vars;

  public RegexNode( int filePos, String str, int flags, boolean regex )
  {
    super( filePos );
    this.str  = str;
    this.flags = flags;
    RParser p = new RParser( regex ? 0 : RParser.FILE_PATTERN_SYNTAX,
			     (flags & TOK_OPT_IGNORE) != 0 );
    try
      {
	regexNode = p.parse( str, (flags & TOK_OPT_RETAINALL)==0 );
      }
    catch( CompilerException e )
      {
	e.setFilePos( filePos + e.getFilePos() + 1 );
	throw e;
      }
    catch( Exception e )
      {
	throw new CompilerException( ERR_R_INTERNAL, filePos, e );
      }
    refList = p.getRefList();
    pickList = p.getPickList();
  }

  public Object eval( Context context )
  {
    return context.evalRegex( this );
  }
}
