/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.tree;

import kmy.regex.util.Formatter;
import kmy.regex.tree.RNode;
import kmy.jint.constants.TokenConst;
import kmy.regex.parser.RParser;

import java.util.Hashtable;

public class ReplacerNode extends TextProcessingNode
{
  public String    formStr;
  public int       flags;

  public Formatter format;

  public RegexNode regex;

  public ReplacerNode( int filePos, String str, String formStr, int flags )
  {
    super( filePos );
    this.formStr  = formStr;
    this.flags = flags;
    regex = new RegexNode( filePos, str, flags|TOK_OPT_RETAINALL, true );
    format = new Formatter( formStr, true );
  }

  public Object eval( Context context )
  {
    return context.evalReplacer( this );
  }
}
