/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.tree;

/**
 *  Subclass of Context, implementing all its eval* methods,
 *  all of them just throwing RuntimeException.
 */
class StubContext extends Context
{

  public Object evalArrayValue( ArrayValueNode arrayValueNode )
  {
    throw new RuntimeException( "Context.evalArrayValue not implemented" );
  }

  public Object evalBody( BodyNode bodyNode )
  {
    throw new RuntimeException( "Context.evalBody not implemented" );
  }

  public Object evalBreak( BreakNode breakNode )
  {
    throw new RuntimeException( "Context.evalBreak not implemented" );
  }

  public Object evalCall( CallNode callNode )
  {
    throw new RuntimeException( "Context.evalCall not implemented" );
  }

  public Object evalCase( CaseNode caseNode )
  {
    throw new RuntimeException( "Context.evalCase not implemented" );
  }

  public Object evalCast( CastNode castNode )
  {
    throw new RuntimeException( "Context.evalCast not implemented" );
  }

  public Object evalCatch( CatchNode catchNode )
  {
    throw new RuntimeException( "Context.evalCatch not implemented" );
  }

  public Object evalClass( ClassNode classNode )
  {
    throw new RuntimeException( "Context.evalClass not implemented" );
  }

  public Object evalCond( CondNode condNode )
  {
    throw new RuntimeException( "Context.evalCond not implemented" );
  }

  public Object evalConst( ConstNode constNode )
  {
    throw new RuntimeException( "Context.evalConst not implemented" );
  }

  public Object evalContinue( ContinueNode continueNode )
  {
    throw new RuntimeException( "Context.evalContinue not implemented" );
  }

  public Object evalDo( DoNode doNode )
  {
    throw new RuntimeException( "Context.evalDo not implemented" );
  }

  public Object evalExpressionStatement( ExpressionStatementNode esNode )
  {
    throw new RuntimeException( "Context.evalExpressionStatement not implemented" );
  }

  public Object evalFor( ForNode forNode )
  {
    throw new RuntimeException( "Context.evalFor not implemented" );
  }

  public Object evalFormat( FormatNode formatNode )
  {
    throw new RuntimeException( "Context.evalFormat not implemented" );
  }

  public Object evalIdentifier( IdentifierNode identifierNode )
  {
    throw new RuntimeException( "Context.evalIdentifier not implemented" );
  }

  public Object evalIf( IfNode ifNode )
  {
    throw new RuntimeException( "Context.evalIf not implemented" );
  }

  public Object evalImportStatement( ImportStatementNode importStatement )
  {
    throw new RuntimeException( "Context.evalImportStatement not implemented" );
  }

  public Object evalInfix( InfixNode infixNode )
  {
    throw new RuntimeException( "Context.evalInfix not implemented" );
  }

  public Object evalLabeled( LabeledNode labeledNode )
  {
    throw new RuntimeException( "Context.evalLabeled not implemented" );
  }

  public Object evalMember( MemberNode memberNode )
  {
    throw new RuntimeException( "Context.evalMember not implemented" );
  }

  public Object evalMethod( MethodNode methodNode )
  {
    throw new RuntimeException( "Context.evalMethod not implemented" );
  }

  public Object evalNew( NewNode newNode )
  {
    throw new RuntimeException( "Context.evalNew not implemented" );
  }

  public Object evalPackageStatement( PackageStatementNode packageStatement )
  {
    throw new RuntimeException( "Context.evalPackageStatement not implemented" );
  }

  public Object evalParameter( ParameterNode parameterNode )
  {
    throw new RuntimeException( "Context.evalParameter not implemented" );
  }

  public Object evalPostfix( PostfixNode postfixNode )
  {
    throw new RuntimeException( "Context.evalPostfix not implemented" );
  }

  public Object evalPrefix( PrefixNode prefixNode )
  {
    throw new RuntimeException( "Context.evalPrefix not implemented" );
  }

  public Object evalRegex( RegexNode regexNode )
  {
    throw new RuntimeException( "Context.evalRegex not implemented" );
  }

  public Object evalReplacer( ReplacerNode replacerNode )
  {
    throw new RuntimeException( "Context.evalReplacer not implemented" );
  }

  public Object evalReturn( ReturnNode returnNode )
  {
    throw new RuntimeException( "Context.evalReturn not implemented" );
  }

  public Object evalSwitch( SwitchNode switchNode )
  {
    throw new RuntimeException( "Context.evalSwitch not implemented" );
  }

  public Object evalSynchronized( SynchronizedNode synchronizedNode )
  {
    throw new RuntimeException( "Context.evalSynchronized not implemented" );
  }

  public Object evalThrow( ThrowNode throwNode )
  {
    throw new RuntimeException( "Context.evalThrow not implemented" );
  }

  public Object evalTry( TryNode tryNode )
  {
    throw new RuntimeException( "Context.evalTry not implemented" );
  }

  public Object evalWhile( WhileNode whileNode )
  {
    throw new RuntimeException( "Context.evalWhile not implemented" );
  }

}
