/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.typer;

import kmy.jint.tree.BasicNode;
import kmy.jint.reflect.AbstractClass;

public class AbstractVariable
{

  static final public Object NOT_CONST = new Object();

  static AbstractVariable NOTHING = new AbstractVariable();

  final String dscr( AbstractClass clazz )
  {
    if( clazz == null )
      return "Ljava/lang/Object";
    else
      return clazz.getDescriptor();
  }

  public AbstractClass getType()
  {
    return null;
  }

  public int getFilePos()
  {
    return 0;
  }
  
  public boolean isStatic()
  {
    return false;
  }

  public void mustBeField()
  {
  }

  public Object getConstValue()
  {
    return NOT_CONST;
  }
}



