/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.util;

import java.util.Enumeration;

public abstract class ClassMethods
{
  public static int VARIABLE = -1;

  public abstract Object getSuperclass( Object clazz );
  public abstract Object[] getImplementedInterfaces( Object clazz );

  public abstract Object getArgListClass();
  public abstract Object getAnyClass();

  /**
   *  Returns object used to name constructors ("<init>").
   */
  public abstract Object getInitName();

  public abstract boolean isAssignableFrom( Object toClazz, Object fromClazz );

  public abstract int getClassModifiers( Object clazz );
  public abstract int getMethodModifiers( Object method );
  public abstract int getFieldModifiers( Object field );

  /**
   *  Package is an opaque object, but must implement equals(Object) correctly.
   */
  public abstract Object getPackage( Object clazz );

  public abstract Enumeration getMethods( Object clazz, Object name, int nargs );

  public abstract Object getMethodDeclaringClass( Object method );

  public abstract Object getReturnType( Object method );

  public abstract Object[] getParameterTypes( Object method );

  public abstract Object getField( Object clazz, Object name );

  public abstract boolean isPrivateAccessible( Object clazz, Object accesorClass );

  public boolean areSame( Object class1, Object class2 ) { return class1 == class2; }
}
