/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.util;

import java.lang.reflect.*;
import kmy.jint.lang.ArgList;
import java.util.Enumeration;

public class JVMConstructorClassMethods extends JVMClassMethods
{
  public JVMConstructorClassMethods()
  {
  }

  public Object getInitName()
  {
    return "<init>";
  }

  public int getMethodModifiers( Object method )
  {
    return ((Constructor)method).getModifiers();
  }

  public Enumeration getMethods( Object clazz, Object name, int nargs )
  {
    return new ConstructorList( (Class)clazz, nargs );
  }

  public Object getMethodDeclaringClass( Object method )
  {
    return ((Constructor)method).getDeclaringClass();
  }

  public Object getReturnType( Object method )
  {
    return voidType;
  }

  public Object[] getParameterTypes( Object method )
  {
    return ((Constructor)method).getParameterTypes();
  }

  static class ConstructorList implements Enumeration
  {

    Constructor[]  methods;
    int            nargs;

    int p = 0;

    ConstructorList( Class clazz, int nargs )
    {
      this.methods = clazz.getDeclaredConstructors();
      this.nargs = nargs;
    }

    private void skip()
    {
      for( ; p < methods.length ; p++ )
	{
	  Constructor m = methods[p];
	  Class[] types = m.getParameterTypes();
	  if( nargs < 0 )
	    {
	      if( types.length > 0 && types[types.length-1] == ArgList.class )
		return;
	    }
	  else
	    if( types.length == nargs )
	      return;
	}
    }

    public Object nextElement()
    {
      skip();
      return methods[p++];
    }

    public boolean hasMoreElements()
    {
      skip();
      return p < methods.length;
    }
  }

}
