/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.util;

import java.lang.reflect.*;
import java.util.Enumeration;
import java.util.Vector;
import java.util.Stack;

import kmy.jint.reflect.*;
import kmy.jint.typer.*;
import kmy.jint.compiler.*;
import kmy.jint.parser.*;
import kmy.jint.tree.StatementNode;
import kmy.jint.tree.MethodNode;

public class JintUtilities
{

  public static MethodNode resolveMethod( JintClass clazz, String method, boolean exact )
  {
    JintClass c = clazz;
    if( c == null ) // can happen when called from superclass constructor
      return null;
    while( true )
      {
	MethodNode body = c.getMethodBody( method );
	if( body != null )
	  return body;
	AbstractClass sup = c.getSuperclass();
	if( ! ( sup instanceof JintClass ) || exact )
	  break;
	c = (JintClass)sup;
      }
    return null;
  }

  public static AbstractField findField(  JintClassTable classTable,	  
	AbstractClass type0, Identifier name, AbstractClass accessor )
  {
    return (AbstractField)classTable.utilities.findField( type0, name, accessor );
  }

  public static Enumeration findMethod( JintClassTable classTable,	  
					   AbstractClass type, Identifier name,
					   AbstractClass[] argTypes, AbstractClass accessor,
					  Enumeration extra, boolean thisClassOnly )
  {
    return classTable.utilities.findMethod( type, name, argTypes,
					    accessor, extra, thisClassOnly );
  }
}


