/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.jint.util;

import java.util.Enumeration;

/**
 *  This is a simple utility class that concatenates two Enumerations together.
 */
public class SequenceEnumeration implements Enumeration
{
  private Enumeration list1;
  private Enumeration list2;

  public SequenceEnumeration( Enumeration list1, Enumeration list2 )
  {
    this.list1 = list1;
    this.list2 = list2;
  }

  public boolean hasMoreElements()
  {
    if( list1 != null )
      {
	if( list1.hasMoreElements() )
	  return true;
	list1 = null;
      }
    return list2.hasMoreElements();
  }

  public Object nextElement()
  {
    if( list1 != null )
      {
	if( list1.hasMoreElements() )
	  return list1.nextElement();
	list1 = null;
      }
    return list2.nextElement();
  }
}
