/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.test.java;

import kmy.jint.lang.*;
import kmy.regex.util.*;

public class FormatterTest
{

  static void command( String form, String[] args )
  {
    Object[] list = new Object[args.length-1];
    for( int i = 1 ; i < args.length ; i++ )
      {
	String ss = args[i].substring(1);
	switch( args[i].charAt(0) )
	  {
	    case 'i' :
	      list[i-1] = new Integer( ss );
	      break;
	    case 's' :
	      list[i-1] = ss;
	      break;
	    case 'd' :
	      list[i-1] = new Double( ss );
	      break;
	    case 'l' :
	      list[i-1] = new Long( ss );
	      break;
	    case 'f' :
	      list[i-1] = new Float( ss );
	      break;
	    case 'c' :
	      list[i-1] = new Character( ss.charAt(0) );
	      break;
	    default:
	      list[i-1] = args[i];
	  }
      }
    Formatter.printf( form, new ArgList( list ) );
  }

  public static void main( String[] args )
  {
    String[] test = { "%s%3d", "sTest", "i12" };
    if( args.length >= 2 )
      command( args[0], args );
    else
      command( test[0], test );
  }
}
