/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.test.java;

public class Scopes
{

  boolean verbose;

  static class Base
  {
    Object test;

    Base( Object t )
    {
      test = t;
    }
  }

  class TrickyInner extends Base
  {
    TrickyInner()
    {
      super( Scopes.this );
    }

    TrickyInner( Object t )
    {
      super( t );
    }
  }

  void test()
  {
    Object q = "test";

    Base b = new TrickyInner( q );
    if( b.test != q )
      System.out.println( "test1: FAILED" );
    else
      if( verbose )
	System.out.println( "test1: passed" );

    b = new TrickyInner();
    if( b.test != this )
      System.out.println( "test2: FAILED" );
    else
      if( verbose )
	System.out.println( "test2: passed" );
  }

  public static void main( String[] args )
  {
    Scopes s = new Scopes();
    s.verbose = args.length == 0 || args[0].indexOf( 'v' ) >= 0;
    s.test();
  }
}
