/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.test.java;

/**
 *  Testing areas: synchronized() statement, for-loop, array initialization
 *  Tested on both javac and jintc on Thu Apr 29 23:35:32 PDT 1999.
 */
public class Sync
{
  static int test( int index, Object lock )
  {
    int i;
    for( i = 1 ; i < 10 ; i++ )
      {
        synchronized( lock )
	  {
	    lock.notify(); // verify that it is locked
	    if( index == 0 )
	      return 0;
	    if( index == 1 )
	      break;
	    if( index == 2 )
	      continue;
	  }
	return -100;
      }
    return i;
  }

  static int runtest( int index )
  {
    Object lock = new Integer( index );
    int res = /*###*/test( index, lock );
    try
      {
	lock.notify();
      }
    catch( IllegalMonitorStateException e )
      {
        return res;
      }
    return -2;
  }

  public static void main( String[] args )
  {
    boolean verbose = args.length == 0 || !args[0].equals( "-s" );
    int[] expected = { 0, 1, 10, -100 };
    for( int i = 0 ; i < 4 ; i++ )
      {
	int res = /*###*/runtest(i);
	boolean failed = expected[i] != res;
	if( verbose || failed )
          {
	    System.out.print( "Sync " + i + ": " );
	    if( failed )
	      {
	        System.out.print( "**FAILED**" );
                if( verbose )
		  System.out.print( " (expected: " + expected[i] + " had: " + res + ")" ); 
		System.out.println();
              }
	    else
	      System.out.println( "passed" );
          }
      }
  }
}
