/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.test.jint;

public class AnyPrime
{
  primeScript( max )
  {
    res = 2;
    test = 3;
    while( test < max )
      {
        int i = 3;
        while( i < test && test % i != 0 )
          i = i + 2; 
        if( i >= test )
	  res = test;
        test = test + 2;
      }
    return res;
  }

  int primeTyped( int max )
  {
    int res = 2;
    int test = 3;
    while( test < max )
      {
        int i = 3;
        while( i < test && test % i != 0 )
          i = i + 2; 
        if( i >= test )
	  res = test;
        test = test + 2;
      }
    return res;
  }

  public static void main( String[] args ) throws Exception
  {    
    boolean perf = args.length == 0 || args[0].indexOf( 'p' ) > 0;
	
    AnyPrime a = new AnyPrime();

    long t = System.currentTimeMillis();
    int res = a.primeScript( 1000 );
    System.out.println( "Script: " + res );
    if( perf )
      System.out.println( " time: " + (System.currentTimeMillis() - t) );

    t = System.currentTimeMillis();
    res = a.primeTyped( 1000 );
    System.out.println( "Typed: " + res );
    if( perf )
      System.out.println( " time: " + (System.currentTimeMillis() - t) );

  }
}
