/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.test.jint;

public class BlockTest
{

  boolean verbose;

  BlockTest( boolean v )
  {
    verbose = v;
  }

  public void repeat( int count, Runnable r )
  {
    for( int i = 0 ; i < count ; i++ )
      r.run();
  }

  public void test()
  {
    int v = 0;
    repeat( 5, [ v++; if( verbose ) System.out.println( "Repeat: " + v ); ] );
    if( v == 5 )
      {
	if( verbose )
	  System.out.println( "Block: passed" );
      }
    else
      System.out.println( "Block [" + v + "]: FAILED" );
  }

  public static void main(  String[] args )
  {
    boolean verbose = args.length == 0 || args[0].indexOf( 'v' ) >= 0;
    (new BlockTest(verbose)).test();
  }

}
