/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.test.jint;

import kmy.regex.util.*;

public class ReTest
{

  static boolean regexProc( Regex regex )
  {
    return "sdgsdafoobuu" ~ regex;
  }

  public static void main(  String[] args )
  {
    boolean verbose = args.length == 0 || args[0].indexOf( 'v' ) >= 0;

    CharString cs = new CharString( 
       "11hdshafoobhsdhgfhgdhsfsyteyghghdsfgfgfczxvcfgsdflsadklkSorotokingfhgds1" );
    cs = cs.substring( 2, cs.length()-1 );
    
    CharString expect = new CharString( "Sorotokin" );
    CharString res = null;

    if( cs ~ m`@res(Sorotokin)` && res.equals( expect ) )
      {
	if( verbose )
	  System.out.println( "Inline plain search: passed" );
      }
    else
      System.out.println( "Inline plain search: FAILED" );

    res = null;

    if( cs ~ m`@res(Sorotokin)`O && res.equals( expect ) )
      {
	if( verbose )
	  System.out.println( "Offline plain search: passed" );
      }
    else
      System.out.println( "Offline plain search: FAILED" );

    CharString start = new CharString( "a" );
    CharString end   = new CharString( "b" );

    String middle = null;

    if( cs ~ m`$start@middle(.*)$end` && middle.equals( "foo" ) )
      {
	if( verbose )
	  System.out.println( "Inline a.*b: passed" );
      }
    else
      System.out.println( "Inline a.*b: FAILED: " + middle );    

    middle = null;

    if( cs ~ m`$start@middle(.*)$end`O && middle.equals( "foo" ) )
      {
	if( verbose )
	  System.out.println( "Offline a.*b: passed" );
      }
    else
      System.out.println( "Offline a.*b: FAILED: " + middle );    

    middle = null;

    if( regexProc( m`$start@middle(.*)$end` ) && middle.equals( "foo" ) )
      {
	if( verbose )
	  System.out.println( "Off-scope a.*b: passed" );
      }
    else
      System.out.println( "Off-scope a.*b: FAILED: " + middle );    


    if( "test.c" ~ p`*.c` )
      {
	if( verbose )
	  System.out.println( "File pattern: passed" );    
      }
    else
      System.out.println( "File pattern: FAILED" );    


    String ext = "Moscow";
    String intr = null;

    if( "sadTYUUsahdMOSCOWUgU" ~ m`^[a-z]*$ext@intr(.*)$`i && intr.equals("UgU") )
      {
	if( verbose )
	  System.out.println( "IgnoreCase: passed" );
      }
    else
      System.out.println( "IgnoreCase: FAILED: " + intr );    

  }
}
