/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.test.jint;

import kmy.regex.util.*;

public class ReTestBig
{
  static int N = 1;
  public static void main( String[] args )
  {
    String[] test = new String[100];
    boolean[] expect = new boolean[100];
    boolean verbose = args.length > 0 && args[0].indexOf( 'v' ) > 0;
    boolean perf = args.length > 0 && args[0].indexOf( 'p' ) > 0;
    N = ( perf ? 10000 : 1 );
    double total = 0.0;

    test[0] = "hdshfghsdhgfhgdhsfsyteyghghdsfgfgfczxvcfgsadflsadklkSorotokingfhgds";
    expect[0] = true;

    if( verbose )
      System.out.println( "--------  Sorotokin " );
    for( int i = 0 ; i < 1 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`Sorotokin`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }

    test[0] = "atyppubty";
    expect[0] = true;
    test[1] = "tytsadhghbfg";
    expect[1] = true;
    test[2] = "akjjsh";
    expect[2] = false;
    test[3] = "klklkb";
    expect[3] = false;

    if( verbose )
      System.out.println( "--------  a(.*)b " );
    for( int i = 0 ; i < 4 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`a(.*)b`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }

    test[0] = "ytsayt0uuu1hgdsssfgdsfsd2ghghs111dfs1ghgdsfsd1hjsdf";
    expect[0] = true;

    if( verbose )
      System.out.println( "--------  0(.*)1.*2 " );
    for( int i = 0 ; i < 1 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`0(.*)1.*2`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }

    test[0] = "adhgfhdshghfgdshfhgdsturyeuoasidoasoijeiwhrjhdjsufyuuhhgreyuytuhjgfhdfjhg";
    expect[0] = false;

    if( verbose )
      System.out.println( "--------  (.*)0 " );
    for( int i = 0 ; i < 1 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`(.*)0`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }

    test[0] = "zzzzz";
    expect[0] = true;
    test[1] = "zzzzzzz";
    expect[1] = true;

    if( verbose )
      System.out.println( "--------  ^((.*z){1,3}){5}$ " );
    for( int i = 0 ; i < 2 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`^((.*z){1,3}){5}$`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }

    test[0] = "zzzzz";
    expect[0] = true;
    test[1] = "zzzzzzzz";
    expect[1] = true;

    if( verbose )
      System.out.println( "--------  ^((.*?z){1,3}){5}$ " );
    for( int i = 0 ; i < 2 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`^((.*?z){1,3}){5}$`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }

    test[0] = "7809";
    expect[0] = true;
    test[1] = "-567";
    expect[1] = true;
    test[2] = "-0890";
    expect[2] = false;
    test[3] = "678y";
    expect[3] = false;

    if( verbose )
      System.out.println( "--------  ^-?[1-9]\d*$ " );
    for( int i = 0 ; i < 4 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`^-?[1-9]\d*$`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }

    test[0] = "cdcda";
    expect[0] = true;
    test[1] = "ccacca";
    expect[1] = true;
    test[2] = "ccaccaa";
    expect[2] = true;
    test[3] = "ccacc";
    expect[3] = false;
    test[4] = "aaaaaa";
    expect[4] = true;
    test[5] = "aaaaaaa";
    expect[5] = true;
    test[6] = "aaaaaaaa";
    expect[6] = true;

    if( verbose )
      System.out.println( "--------  ^(([a-z]+)\2a)*$ " );
    for( int i = 0 ; i < 7 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`^(([a-z]+)\2a)*$`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }

    test[0] = "aaa ";
    expect[0] = true;
    test[1] = "    bb";
    expect[1] = true;
    test[2] = "aaabbb";
    expect[2] = false;

    if( verbose )
      System.out.println( "--------  ([a ]+)\b([b ]+) " );
    for( int i = 0 ; i < 3 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`([a ]+)\b([b ]+)`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }

    test[0] = "aaabbbaaabbbb";
    expect[0] = true;
    test[1] = "aaabaaabba";
    expect[1] = true;
    test[2] = "sfgsu";
    expect[2] = false;

    if( verbose )
      System.out.println( "--------  (a+|b+)+ " );
    for( int i = 0 ; i < 3 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`(a+|b+)+`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }

    test[0] = "ababac";
    expect[0] = true;
    test[1] = "abd";
    expect[1] = false;

    if( verbose )
      System.out.println( "--------  ^([ab]+?)[ac] " );
    for( int i = 0 ; i < 2 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`^([ab]+?)[ac]`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }

    test[0] = "yyybc";
    expect[0] = true;
    test[1] = "atasd";
    expect[1] = true;
    test[2] = "tytsdfbcas";
    expect[2] = false;

    if( verbose )
      System.out.println( "--------  (^a|bc$) " );
    for( int i = 0 ; i < 3 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`(^a|bc$)`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }

    test[0] = "aaabbbcccrrrc";
    expect[0] = true;
    test[1] = "aaarrracccrrrc";
    expect[1] = true;

    if( verbose )
      System.out.println( "--------  (([a-z])\2*)*rrr\2 " );
    for( int i = 0 ; i < 2 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`(([a-z])\2*)*rrr\2`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }

    test[0] = "ghgsahdaqa";
    expect[0] = true;

    if( verbose )
      System.out.println( "--------  ([a-z])+q\1 " );
    for( int i = 0 ; i < 1 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`([a-z])+q\1`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }

    test[0] = "ioioioidifoidsugdghdfugherjhuyehgdsgfhgtr";
    expect[0] = false;
    test[1] = "peterhsgfhgsdfgdshfghgdshgfhdsfvbdvfgfsdfvbvgdfsfhjdshfhsdf";
    expect[1] = true;

    if( verbose )
      System.out.println( "--------  [a-z]*ter " );
    for( int i = 0 ; i < 2 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`[a-z]*ter`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }

    test[0] = "peterhsgfhgsdfgdshfghgdshgfhdsfvbdvfgfsdfvbvgdfsfhjdshfhsdf";
    expect[0] = true;
    test[1] = "ioioioidifoidsugdghdfugherjhuyehgdsgfhgtr";
    expect[1] = false;

    if( verbose )
      System.out.println( "--------  ([a-z]*ter) " );
    for( int i = 0 ; i < 2 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`([a-z]*ter)`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }

    test[0] = "aba";
    expect[0] = true;
    test[1] = "aaba";
    expect[1] = true;
    test[2] = "aabaa";
    expect[2] = true;
    test[3] = "aaaba";
    expect[3] = true;
    test[4] = "aaabaa";
    expect[4] = true;
    test[5] = "aaabaaa";
    expect[5] = true;
    test[6] = "aaaaba";
    expect[6] = true;

    if( verbose )
      System.out.println( "--------  ^(a*?){1,2}b\1$ " );
    for( int i = 0 ; i < 7 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`^(a*?){1,2}b\1$`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }

    test[0] = "aaaaaaacaaaab";
    expect[0] = true;

    if( verbose )
      System.out.println( "--------  a{3,5}b " );
    for( int i = 0 ; i < 1 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`a{3,5}b`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }

    test[0] = "theword";
    expect[0] = false;
    test[1] = "the word";
    expect[1] = true;
    test[2] = "the wordie";
    expect[2] = false;
    test[3] = "a word of wisdom";
    expect[3] = true;

    if( verbose )
      System.out.println( "--------  <word> " );
    for( int i = 0 ; i < 4 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`<word>`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }

    test[0] = "-12.45e+67";
    expect[0] = true;
    test[1] = "123.8";
    expect[1] = true;
    test[2] = "+67.68.90";
    expect[2] = false;
    test[3] = "345.54e+78.6";
    expect[3] = false;
    test[4] = "-.67e-02";
    expect[4] = true;

    if( verbose )
      System.out.println( "--------  ^([+-]?)(\d*)(?:\.(\d*))?(?:[Ee]([+-]?\d+))?$ " );
    for( int i = 0 ; i < 5 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`^([+-]?)(\d*)(?:\.(\d*))?(?:[Ee]([+-]?\d+))?$`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }

    test[0] = "-yuodsf";
    expect[0] = true;
    test[1] = "sa-ydfdsa";
    expect[1] = false;

    if( verbose )
      System.out.println( "--------  ^- " );
    for( int i = 0 ; i < 2 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`^-`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }

    test[0] = "123.45.23.90";
    expect[0] = true;
    test[1] = "12434.yut.7";
    expect[1] = false;
    test[2] = "www.entire.com";
    expect[2] = false;

    if( verbose )
      System.out.println( "--------  ^(\d+)\.(\d+)\.(\d+)\.(\d+)$ " );
    for( int i = 0 ; i < 3 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`^(\d+)\.(\d+)\.(\d+)\.(\d+)$`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }

    test[0] = "098";
    expect[0] = false;
    test[1] = "78gf";
    expect[1] = false;
    test[2] = "96iuoi";
    expect[2] = false;
    test[3] = "hjahsa789";
    expect[3] = true;

    if( verbose )
      System.out.println( "--------  ^([^0-9]+) " );
    for( int i = 0 ; i < 4 ; i++ )
      {
        CharString t = new CharString( test[i] );
        long time1 = System.currentTimeMillis();
        boolean passed = true;
        for( int j = 0 ; j < N ; j++ )
	     if( (t ~ m`^([^0-9]+)`) != expect[i] )
	       passed = false;
	   if( !passed )
          System.out.println( t + ": FAILED (" + !expect[i] + ")" );
        else
          if( verbose && !perf )
            System.out.println( t + ": passed (" + expect[i] + ")" );
        long time2 = System.currentTimeMillis();
        double average = (time2 - time1)/(double)N;
        total += average;
        if( N > 1 )
          System.out.println( (verbose? t + ": ": "" ) + average );
      }
     if( N > 1 )
       System.out.println( "Total: " + total );
  }
}
