/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.test.jint;

public class Scopes
{

  System.out.println( "Point 1" );

  void f( String s )
  {
    Object m = this;
    if( ! (m instanceof Scopes) )
      throw new RuntimeException( "this variable is not Scope: " + this );
    System.out.println( "Point " + s );
  }

  class A
  {
    System.out.println( "Point 2" );
    A()
    {
      f( "3" );
    }
  }

  void test()
  {
    int a = 6;

    class B
    {
      System.out.println( "Point 4" );

      B()
      {
	f( "5" );
      }
    }

    if( a == 6 )
      {
	void fun( int q )
	  {
	    System.out.println( "Point " + q );
	  }
	new A();
	new B();
	fun( a );
      }
  }

  public static void main( String[] args )
  {
    (new Scopes()).test();
  }
}
