/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.test.jint;

import kmy.regex.util.*;

public class SubstTest
{

  static String substProc( String s, Replacer rep )
  {
    return s ~ rep;
  }

  public static void main(  String[] args )
  {
    boolean verbose = args.length == 0 || args[0].indexOf( 'v' ) >= 0;

    CharString cs = new CharString( "11*foo*1" );
    cs = cs.substring( 2, cs.length()-1 );
    
    CharString expect = new CharString( "*blah*" );
    CharString res = null;
 
    String str;

    res = cs ~ s`foo`blah`;

    if( res.equals( expect ) )
      {
	if( verbose )
	  System.out.println( "Plain: passed" );
      }
    else
      System.out.println( "Plain: FAILED: " + res );

    String r = cs.toString() ~ s`[^a-z]`#`g;

    if( r.equals( "#foo#" ) )
      {
	if( verbose )
	  System.out.println( "Global: passed" );
      }
    else
      System.out.println( "Global: FAILED: " + r );    

    r = "(a)(100)(bc)" ~ s`\(@str([a-z]+)\)`[$str]`g;

    if( r.equals( "[a](100)[bc]" ) )
      {
	if( verbose )
	  System.out.println( "Complex: passed" );
      }
    else
      System.out.println( "Complex: FAILED: " + r );

    r = substProc( "(a)(100)(bc)", s`\(@str([a-z]+)\)`[$str]`g );

    if( r.equals( "[a](100)[bc]" ) )
      {
	if( verbose )
	  System.out.println( "OutOfScope: passed" );
      }
    else
      System.out.println( "OutOfScope: FAILED: " + r );


    r = " t23 ";
    r ~= s`t(\d+)`u${1%010d}`;

    if( r.equals( " u0000000023 " ) )
      {
	if( verbose )
	  System.out.println( "InPlace: passed" );
      }
    else
      System.out.println( "InPlace: FAILED: " + r );

  }

}
