/*
    Copyright (c) Peter Sorotokin, 1998-2000
    See file "License.html" for terms of usage and
    redistribution.   
*/
package kmy.test.jint;

public class Switches
{
  public static void main(  String[] args )
  {
    boolean verbose = args.length == 0 || args[0].indexOf( 'v' ) >= 0;
    Switches.intTest( verbose );
    Switches.lookupTest( verbose );
    Switches.anyTest( verbose );
  }

  public static void intTest( boolean verbose )
  {
    System.out.println( "------------ intTest -----------" );
    boolean fallThrough = false;
    for( int i = 0 ; i < 10 ; i++ )
      {
	switch( i )
	  {
	    case 0 :
	      if( i != 0 )
		System.out.println( "Case 0 : FAILED" );
	      else
		if( verbose )
		  System.out.println( "Case 0 : passed" );
	      break;
	    case 2 :
	      if( i != 2 )
		System.out.println( "Case 2 : FAILED" );
	      else
		if( verbose )
		  System.out.println( "Case 2 : passed" );
	      break;
	    case 4 :
	      if( i != 4 )
		System.out.println( "Case 4 : FAILED" );
	      else
		if( verbose )
		  System.out.println( "Case 4 : passed" );
	      break;
	    case 6 :
	      if( i != 6 )
		System.out.println( "Case 6 : FAILED" );
	      else
		if( verbose )
		  System.out.println( "Case 6 : passed" );
	    case 8 :
	      if( i == 6 )
		fallThrough = true;
	      if( i != 6 && i != 8 )
		System.out.println( "Case 6/8 [" + i + "]: FAILED" );
	      else
		if( verbose )
		  System.out.println( "Case 6/8 [" + i + "]: passed" );
	      break;
	    default :
	      if( i % 2 == 0 )
		System.out.println( "Default [" + i + "]: FAILED" );
	      else
		if( verbose )
		  System.out.println( "Default [" + i + "]: passed" );
	      break;
	  }
	if( verbose )
	  System.out.println( "After switch" );
      }
    if( fallThrough )
      {
	if( verbose )
	  System.out.println( "Fall through: passed" );
      }
    else
      System.out.println( "Fall through: FAILED" );
  }

  public static void lookupTest( boolean verbose )
  {
    System.out.println( "------------ lookupTest -----------" );
    boolean fallThrough = false;
    for( int i = 0 ; i < 5 ; i++ )
      {
	switch( i*i*i*i )
	  {
	    case 0 :
	      if( i != 0 )
		System.out.println( "Case 0 : FAILED" );
	      else
		if( verbose )
		  System.out.println( "Case 0 : passed" );
	      break;
	    case 16 :
	      if( i != 2 )
		System.out.println( "Case 2 : FAILED" );
	      else
		if( verbose )
		  System.out.println( "Case 2 : passed" );
	      break;
	    default :
	      if( i != 4 )
		System.out.println( "Case 4 : FAILED" );
	      else
		if( verbose )
		  System.out.println( "Case 4 : passed" );
	    case 81 :
	      if( i == 4 )
		{
		  fallThrough = true;
		  break;
		}
	      if( i != 3 )
		System.out.println( "Case 3 : FAILED" );
	      else
		if( verbose )
		  System.out.println( "Case 3 : passed" );
	      break;
	    case 1 :
	      if( i != 1 )
		System.out.println( "Case 1 : FAILED" );
	      else
		if( verbose )
		  System.out.println( "Case 1 : passed" );
	      break;
	  }
      }
    if( fallThrough )
      {
	if( verbose )
	  System.out.println( "Fall through: passed" );
      }
    else
      System.out.println( "Fall through: FAILED" );
  }

  public static void anyTest( boolean verbose )
  {
    System.out.println( "------------ anyTest -----------" );
    boolean fallThrough = false;
    Any i = 0;
    while( i < 10 )
      {
	switch( i )
	  {
	    case 0 :
	      if( i != 0 )
		System.out.println( "Case 0 : FAILED" );
	      else
		if( verbose )
		  System.out.println( "Case 0 : passed" );
	      break;
	    case 2 :
	      if( i != 2 )
		System.out.println( "Case 2 : FAILED" );
	      else
		if( verbose )
		  System.out.println( "Case 2 : passed" );
	      break;
	    case 4 :
	      if( i != 4 )
		System.out.println( "Case 4 : FAILED" );
	      else
		if( verbose )
		  System.out.println( "Case 4 : passed" );
	      break;
	    case 6 :
	      if( i != 6 )
		System.out.println( "Case 6 : FAILED" );
	      else
		if( verbose )
		  System.out.println( "Case 6 : passed" );
	    case 8 :
	      if( i == 6 )
		fallThrough = true;
	      if( i != 6 && i != 8 )
		System.out.println( "Case 6/8 [" + i + "]: FAILED" );
	      else
		if( verbose )
		  System.out.println( "Case 6/8 [" + i + "]: passed" );
	      break;
	    default :
	      if( i % 2 == 0 )
		System.out.println( "Default [" + i + "]: FAILED" );
	      else
		if( verbose )
		  System.out.println( "Default [" + i + "]: passed" );
	      break;
	  }
	if( verbose )
	  System.out.println( "After switch" );
	i = i + 1;
      }
    if( fallThrough )
      {
	if( verbose )
	  System.out.println( "Fall through: passed" );
      }
    else
      System.out.println( "Fall through: FAILED" );
  }

}
